#include<bits/stdc++.h>

using namespace std;

struct edge
{
    int type, x, y, val;
    edge() { }
    edge(int type, int x, int y, int val) :type(type), x(x), y(y), val(val) { }
};

const int nmax=200010;
int timer;
vector<int> v[nmax];
pair<int, int> tree[4*nmax];
int t1[4*nmax], t2[4*nmax];
bool lazy[nmax];
int lazy1[4*nmax], lazy2[4*nmax];
int m[nmax];
edge q[nmax];

void push(int root)
{
    if(lazy[root])
    {
        tree[root*2].first=tree[root*2].second=tree[root*2+1].first=tree[root*2+1].second=tree[root].first;
        lazy[root*2]=lazy[root*2+1]=lazy[root];
        lazy[root]=0;
    }
}

void push1(int root)
{
    if(lazy1[root])
    {
        t1[root*2]+=lazy1[root];
        t1[root*2+1]+=lazy1[root];
        lazy1[root*2]+=lazy1[root];
        lazy1[root*2+1]+=lazy1[root];
        lazy1[root]=0;
    }
}

void push2(int root)
{
    if(lazy2[root])
    {
        t2[root*2]+=lazy2[root];
        t2[root*2+1]+=lazy2[root];
        lazy2[root*2]+=lazy2[root];
        lazy2[root*2+1]+=lazy2[root];
        lazy2[root]=0;
    }
}

pair<int, int> query(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr) return tree[root];
    push(root);
    int mid=(l+r)/2;
    if(qr<=mid) return query(root*2, l, mid, ql, qr);
    if(ql>mid) return query(root*2+1, mid+1, r, ql ,qr);
    pair<int, int> i1=query(root*2, l, mid, ql, mid);
    pair<int, int> i2=query(root*2+1, mid+1, r, mid+1, qr);
    i1.first=max(i1.first, i2.first);
    i1.second=min(i1.second, i2.second);
    return i1;
}

void update(int root, int l, int r, int ql, int qr, int x)
{
    //cout<<root<<" "<<l<<" "<<r<<" "<<ql<<" "<<qr<<endl;
    if(l==ql&&r==qr)
    {
        tree[root].first=tree[root].second=x;
        lazy[root]=1;
    }
    else
    {
        push(root);
        int mid=(l+r)/2;
        if(qr<=mid) update(root*2, l, mid, ql, qr, x);
        else if(ql>mid) update(root*2+1, mid+1, r, ql, qr, x);
        else
        {
            update(root*2, l, mid, ql, mid, x);
            update(root*2+1, mid+1, r, mid+1, qr, x);
        }
        tree[root].first=max(tree[root*2].first, tree[root*2+1].first);
        tree[root].second=min(tree[root*2].second, tree[root*2+1].second);
    }
}

int query1(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr) return t1[root];
    push1(root);
    int mid=(l+r)/2;
    if(qr<=mid) return query1(root*2, l, mid, ql, qr);
    if(ql>mid) return query1(root*2+1, mid+1, r, ql ,qr);
    return max(query1(root*2, l, mid, ql, mid), query1(root*2+1, mid+1, r, mid+1, qr));
}

void update1(int root, int l, int r, int ql, int qr, int x)
{
    //cout<<root<<" "<<l<<" "<<r<<" "<<ql<<" "<<qr<<endl;
    if(l==ql&&r==qr)
    {
        t1[root]+=lazy1[root]+1;
        lazy1[root]++;
    }
    else
    {
        push1(root);
        int mid=(l+r)/2;
        if(qr<=mid) update1(root*2, l, mid, ql, qr, x);
        else if(ql>mid) update1(root*2+1, mid+1, r, ql, qr, x);
        else
        {
            update1(root*2, l, mid, ql, mid, x);
            update1(root*2+1, mid+1, r, mid+1, qr, x);
        }
        t1[root]=max(t1[root*2], t1[root*2+1]);
    }
}

int query2(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr) return t2[root];
    push2(root);
    int mid=(l+r)/2;
    if(qr<=mid) return query2(root*2, l, mid, ql, qr);
    if(ql>mid) return query2(root*2+1, mid+1, r, ql ,qr);
    return min(query2(root*2, l, mid, ql, mid), query2(root*2+1, mid+1, r, mid+1, qr));
}

void update2(int root, int l, int r, int ql, int qr, int x)
{
    //cout<<root<<" "<<l<<" "<<r<<" "<<ql<<" "<<qr<<endl;
    if(l==ql&&r==qr)
    {
        t2[root]+=lazy2[root]+1;
        lazy2[root]++;
    }
    else
    {
        push2(root);
        int mid=(l+r)/2;
        if(qr<=mid) update2(root*2, l, mid, ql, qr, x);
        else if(ql>mid) update2(root*2+1, mid+1, r, ql, qr, x);
        else
        {
            update2(root*2, l, mid, ql, mid, x);
            update2(root*2+1, mid+1, r, mid+1, qr, x);
        }
        t2[root]=max(t2[root*2], t2[root*2+1]);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, qq, type, x, l, r;
    cin>>n>>qq;
    if(n<=3000)
    {
        for(int i=1; i<=n; ++i)
            for(int j=0; j<=3000; ++j) v[i].push_back(0);
        while(qq--)
        {
            cin>>type;
            if(type==1)
            {
                cin>>l>>r>>x;
                if(m[x]==0) m[x]=++timer;
                int id=m[x];
                for(int i=l; i<=r; ++i)
                {
                    v[i][id]++;
                }
            }
            else
            {
                int lamp=0;
                cin>>l>>r;
                for(int i=l+1; i<=r; ++i)
                {
                    for(int j=1; j<=timer; ++j) if(v[i][j]!=v[l][j])
                    {
                        lamp=1;
                        break;
                    }
                    if(lamp==1) break;
                }
                if(lamp==1) cout<<0<< endl;
                else cout<<1<< endl;
            }
        }
        return 0;
    }
    if(n>3000)
    {
        bool lampa=0;
        for(int i=0; i<qq; ++i)
        {
            cin>>type;
            if(type==1)
            {
                cin>>l>>r>>x;
                q[i]={type, l, r, x};
                if(x!=1) lampa=1;
            }
            else
            {
                cin>>l>>r;
                q[i]={type, l, r, 0};
            }
        }
        if(lampa==0)
        {
            //cout<<"YES"<<endl;
            for(int i=0; i<qq; ++i)
            {
                if(q[i].type==1)
                {
                    update1(1, 1, n, q[i].x, q[i].y, 1);
                    update2(1, 1, n, q[i].x, q[i].y, 1);
                }
                else
                {
                    int d1=query1(1, 1, n, q[i].x, q[i].y);
                    int d2=query2(1, 1, n, q[i].x, q[i].y);
                    //cout<<d.x<<" "<<d.y<<" "<<q[i].x<<" "<<q[i].y<<endl;
                    //for(int j=1; j<=4*n; ++j) cout<<tree1[j].val<<" ";
                    if(d1==d2) cout<<1<< endl;
                    else cout<<0<< endl;
                }
            }
            return 0;
        }
        for(int i=0; i<qq; ++i)
        {
            if(q[i].type==1)
            {
                update(1, 1, n, q[i].x, q[i].y, q[i].val);
            }
            else
            {
                pair<int, int> d=query(1, 1, n, q[i].x, q[i].y);
                if(d.first==d.second) cout<<1<< endl;
                else cout<<0<< endl;
            }
        }
        return 0;
    }
    while(qq--)
    {
        cin>>type;
        if(type==1)
        {
            cin>>l>>r>>x;
            for(int i=l; i<=r; ++i) v[i].push_back(x);
        }
        else
        {
            cin>>l>>r;
            bool lamp=0;
            for(int i=l; i<=r; ++i) sort(v[i].begin(), v[i].end());
            for(int i=l+1; i<=r; ++i) if(v[i]!=v[l])
            {
                lamp=1;
                break;
            }
            if(lamp==1) cout<<0<< endl;
            else cout<<1<< endl;
        }
    }
    return 0;
}
/*
4 7
2 1 3
1 1 3 1
1 3 4 1
2 1 3
2 1 2
1 2 2 1
2 1 2

*/
