#include<bits/stdc++.h>

using namespace std;

struct edge
{
    int type, x, y, val;
    edge() { }
    edge(int type, int x, int y, int val) :type(type), x(x), y(y), val(val) { }
};

const int nmax=200010;
int timer;
vector<int> v[nmax];
pair<int, int> tree[4*nmax];
int tmax[4*nmax], tmin[4*nmax];
bool lazy[nmax];
int lmax[4*nmax], lmin[4*nmax];
int m[nmax];
edge q[nmax];

void push(int root)
{
    if(lazy[root])
    {
        tree[root*2].first=tree[root*2].second=tree[root*2+1].first=tree[root*2+1].second=tree[root].first;
        lazy[root*2]=lazy[root*2+1]=lazy[root];
        lazy[root]=0;
    }
}

void pmax(int root)
{
    if(lmax[root])
    {
        tmax[root*2]=lmax[root];
        tmax[root*2+1]=lmax[root];
        lmax[root*2]=lmax[root];
        lmax[root*2+1]=lmax[root];
    }
}

void pmin(int root)
{
    if(lmin[root])
    {
        tmin[root*2]=lmin[root];
        tmin[root*2+1]=lmin[root];
        lmin[root*2]=lmin[root];
        lmin[root*2+1]=lmin[root];
        //lmin[root]=0;
    }
}

pair<int, int> query(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr) return tree[root];
    push(root);
    int mid=(l+r)/2;
    if(qr<=mid) return query(root*2, l, mid, ql, qr);
    if(ql>mid) return query(root*2+1, mid+1, r, ql ,qr);
    pair<int, int> i1=query(root*2, l, mid, ql, mid);
    pair<int, int> i2=query(root*2+1, mid+1, r, mid+1, qr);
    i1.first=max(i1.first, i2.first);
    i1.second=min(i1.second, i2.second);
    return i1;
}

void update(int root, int l, int r, int ql, int qr, int x)
{
    //cout<<root<<" "<<l<<" "<<r<<" "<<ql<<" "<<qr<<endl;
    if(l==ql&&r==qr)
    {
        tree[root].first=tree[root].second=x;
        lazy[root]=1;
    }
    else
    {
        push(root);
        int mid=(l+r)/2;
        if(qr<=mid) update(root*2, l, mid, ql, qr, x);
        else if(ql>mid) update(root*2+1, mid+1, r, ql, qr, x);
        else
        {
            update(root*2, l, mid, ql, mid, x);
            update(root*2+1, mid+1, r, mid+1, qr, x);
        }
        tree[root].first=max(tree[root*2].first, tree[root*2+1].first);
        tree[root].second=min(tree[root*2].second, tree[root*2+1].second);
    }
}

int query_max(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr) return tmax[root];
    pmax(root);
    int mid=(l+r)/2;
    if(qr<=mid) return query_max(root*2, l, mid, ql, qr);
    if(ql>mid) return query_max(root*2+1, mid+1, r, ql, qr);
    return max(query_max(root*2, l, mid, ql, mid), query_max(root*2+1, mid+1, r, mid+1, qr));
}

int query_min(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr) return tmin[root];
    pmin(root);
    int mid=(l+r)/2;
    if(qr<=mid) return query_min(root*2, l, mid, ql, qr);
    if(ql>mid) return query_min(root*2+1, mid+1, r, ql, qr);
    return min(query_min(root*2, l, mid, ql, mid), query_min(root*2+1, mid+1, r, mid+1, qr));
}

void update_max(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr)
    {
        lmax[root]++;
        tmax[root]=lmax[root];
        return;
    }
    pmax(root);
    int mid=(l+r)/2;
    if(qr<=mid) update_max(root*2, l, mid, ql, qr);
    else if(ql>mid) update_max(root*2+1, mid+1, r, ql, qr);
    else
    {
        update_max(root*2, l, mid, ql, mid);
        update_max(root*2+1, mid+1, r, mid+1, qr);
    }
    tmax[root]=max(tmax[root*2], tmax[root*2+1]);
}

void update_min(int root, int l, int r, int ql, int qr)
{
    if(l==ql&&r==qr)
    {
        lmin[root]++;
        tmin[root]=lmin[root];
        return;
    }
    pmin(root);
    int mid=(l+r)/2;
    if(qr<=mid) update_min(root*2, l, mid, ql, qr);
    else if(ql>mid) update_min(root*2+1, mid+1, r, ql, qr);
    else
    {
        update_min(root*2, l, mid, ql, mid);
        update_min(root*2+1, mid+1, r, mid+1, qr);
    }
    tmin[root]=min(tmin[root*2], tmin[root*2+1]);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, qq, type, x, l, r;
    cin>>n>>qq;
    if(n<=3000)
    {
        for(int i=1; i<=n; ++i)
            for(int j=0; j<=3000; ++j) v[i].push_back(0);
        while(qq--)
        {
            cin>>type;
            if(type==1)
            {
                cin>>l>>r>>x;
                if(m[x]==0) m[x]=++timer;
                int id=m[x];
                for(int i=l; i<=r; ++i)
                {
                    v[i][id]++;
                }
            }
            else
            {
                int lamp=0;
                cin>>l>>r;
                for(int i=l+1; i<=r; ++i)
                {
                    for(int j=1; j<=timer; ++j) if(v[i][j]!=v[l][j])
                    {
                        lamp=1;
                        break;
                    }
                    if(lamp==1) break;
                }
                if(lamp==1) cout<<0<< endl;
                else cout<<1<< endl;
            }
        }
        return 0;
    }
    if(n>3000)
    {
        bool lampa=0;
        for(int i=0; i<qq; ++i)
        {
            cin>>type;
            if(type==1)
            {
                cin>>l>>r>>x;
                q[i]={type, l, r, x};
                if(x!=1) lampa=1;
            }
            else
            {
                cin>>l>>r;
                q[i]={type, l, r, 0};
            }
        }
        if(lampa==0)
        {
            //cout<<"YES"<<endl;
            for(int i=0; i<qq; ++i)
            {
                if(q[i].type==1)
                {
                    update_max(1, 1, n, q[i].x, q[i].y);
                    update_min(1, 1, n, q[i].x, q[i].y);
                }
                else
                {
                    int d1=query_max(1, 1, n, q[i].x, q[i].y);
                    int d2=query_min(1, 1, n, q[i].x, q[i].y);
                    /*cout<<d1<<" "<<d2<<" "<<q[i].x<<" "<<q[i].y<<endl;
                    for(int j=1; j<=4*n; ++j) cout<<tmax[j]<<" ";
                    cout<<endl;
                    for(int j=1; j<=4*n; ++j) cout<<tmin[j]<<" ";
                    cout<<endl;
                    for(int j=1; j<=4*n; ++j) cout<<lmax[j]<<" ";
                    cout<<endl;
                    for(int j=1; j<=4*n; ++j) cout<<lmin[j]<<" ";
                    cout<<endl;*/
                    if(d1==d2) cout<<1<< endl;
                    else cout<<0<< endl;
                }
            }
            return 0;
        }
        for(int i=0; i<qq; ++i)
        {
            if(q[i].type==1)
            {
                update(1, 1, n, q[i].x, q[i].y, q[i].val);
            }
            else
            {
                pair<int, int> d=query(1, 1, n, q[i].x, q[i].y);
                if(d.first==d.second) cout<<1<< endl;
                else cout<<0<< endl;
            }
        }
        return 0;
    }
    while(qq--)
    {
        cin>>type;
        if(type==1)
        {
            cin>>l>>r>>x;
            for(int i=l; i<=r; ++i) v[i].push_back(x);
        }
        else
        {
            cin>>l>>r;
            bool lamp=0;
            for(int i=l; i<=r; ++i) sort(v[i].begin(), v[i].end());
            for(int i=l+1; i<=r; ++i) if(v[i]!=v[l])
            {
                lamp=1;
                break;
            }
            if(lamp==1) cout<<0<< endl;
            else cout<<1<< endl;
        }
    }
    return 0;
}
/*
4 7
2 1 3
1 1 3 1
1 3 4 1
2 1 3
2 1 2
1 2 2 1
2 1 2

*/
