#include <iostream>
#include <unordered_set>

using namespace std;

const int maxn = 2*10e5 + 5;
unordered_multiset <int> L[maxn];
unordered_multiset <int> R[maxn];

bool Rcontains (int i, int x){
    for(auto it = R[i].begin(); it !=R[i].end(); ++it){
        if(*it == x) return 1;
    }
    return 0;
}

bool Lcontains (int i, int x){
    for(auto it = L[i].begin(); it !=L[i].end(); ++it){
        if(*it == x) return 1;
    }
    return 0;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, q;
    cin >> n >> q;

    for(int qn = 1; qn <= q; qn++){ ///qn = question number
        int qt;  ///qt = question type
        cin >> qt;
        if(qt == 1){
            int l, r, x;
            cin >> l >> r >> x;

            if(Rcontains(l-1,x)) R[l-1].erase(x);
            else L[l].insert(x);

            if(Lcontains(r+1,x)) L[r+1].erase(x);
            else R[r].insert(x);
        }
        else{  ///qt == 2
            int l,r;
            cin >> l >> r;

            if(!R[l].empty() || !L[r].empty()){
                //cout << "*Ans to question number " << qn << ": " << 0 << endl;
                cout << 0 << endl;
                continue;
            }
            bool areEqual = true;
            for(int i=l+1; i<=r-1; i++){
                if(!L[i].empty() || !R[i].empty()){
                    //cout << "&Ans to question number " << qn << ": " << 0 << endl;
                    cout << 0 << endl;
                    areEqual = false;
                    break;
                }
            }
            if(!areEqual) continue;
            //cout << "$Ans to question number " << qn << ": " << 1 << endl;
            cout << 1 << endl;
        }
    }

    return 0;
}
