
#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

struct Node {
    int minValue;
    int maxValue;
    int lazy;

    Node(int minValue = 0, int maxValue = 0) {
        this->minValue = minValue;
        this->maxValue = maxValue;
        this->lazy = 0;
    }

    Node operator +(Node rhs) {
        return Node(min(this->minValue, rhs.minValue), max(this->maxValue, rhs.maxValue));
    }
};

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;

void read() {
    cin >> n >> q;
}

vector<Node> tree;

void push(int node, int low, int high) {
    if (tree[node].lazy) {
        tree[node].minValue += tree[node].lazy;
        tree[node].maxValue += tree[node].lazy;

        if (low != high) {
            tree[node << 1].lazy += tree[node].lazy;
            tree[node << 1 | 1].lazy += tree[node].lazy;
        }

        tree[node].lazy = 0;
    }
}

void update(int node, int low, int high, int ql, int qr) {
    push(node, low, high);

    if (high < ql || low > qr) {
        return;
    }

    if (low >= ql && high <= qr) {
        tree[node].lazy++;
        push(node, low, high);

        return;
    }

    int mid = low + ((high - low) >> 1);
    update(node << 1, low, mid, ql, qr);
    update(node << 1 | 1, mid + 1, high, ql, qr);

    tree[node] = tree[node << 1] + tree[node << 1 | 1];
}

Node query(int node, int low, int high, int ql, int qr) {
    push(node, low, high);

    if (high < ql || low > qr) {
        return Node(1e9, -1e9);
    }

    if (low >= ql && high <= qr) {
        return tree[node];
    }

    int mid = low + ((high - low) >> 1);
    return query(node << 1, low, mid, ql, qr) + query(node << 1 | 1, mid + 1, high, ql, qr);
}

void solve() {
    tree.resize(n << 2);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;

        l--;
        r--;

        if (type == 1) {
            int t;
            cin >> t;

            update(1, 0, n - 1, l, r);
        } else {
            Node answer = query(1, 0, n - 1, l, r);

            cout << (answer.minValue == answer.maxValue) << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}
