
#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;

void read() {
    cin >> n >> q;
}

vector<map<int, pair<int, int>>> tree;
vector<map<int, int>> lazy;

void push(int node, int low, int high) {
    if (!lazy[node].empty()) {
        for (auto &i : lazy[node]) {
            tree[node][i.first].first += i.second;
            tree[node][i.first].second += i.second;
        }

        if (low != high) {
            for (auto &i : lazy[node]) {
                lazy[node << 1][i.first] += i.second;
                lazy[node << 1 | 1][i.first] += i.second;
            }
        }

        lazy[node].clear();
    }
}

void update(int node, int low, int high, int ql, int qr, int type, int delta) {
    push(node, low, high);

    if (high < ql || low > qr) {
        return;
    }

    if (low >= ql && high <= qr) {
        lazy[node][type] += delta;
        push(node, low, high);

        return;
    }

    int mid = low + ((high - low) >> 1);
    update(node << 1, low, mid, ql, qr, type, delta);
    update(node << 1 | 1, mid + 1, high, ql, qr, type, delta);

    tree[node] = tree[node << 1];

    for (auto &i : tree[node << 1 | 1]) {
        tree[node][i.first].first = min(tree[node][i.first].first, i.second.first);
        tree[node][i.first].second = max(tree[node][i.first].second, i.second.second);
    }
}

map<int, pair<int, int>> query(int node, int low, int high, int ql, int qr) {
    push(node, low, high);

    if (high < ql || low > qr) {
        return map<int, pair<int, int>>();
    }

    if (low >= ql && high <= qr) {
        return tree[node];
    }

    int mid = low + ((high - low) >> 1);
    map<int, pair<int, int>> l = query(node << 1, low, mid, ql, qr);
    map<int, pair<int, int>> r = query(node << 1 | 1, mid + 1, high, ql, qr);

    for (auto &i : r) {
        l[i.first].first = min(l[i.first].first, i.second.first);
        l[i.first].second = max(l[i.first].second, i.second.second);
    }

    return l;
}

void solve() {
    tree.resize(n << 2);
    lazy.resize(n << 2);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;

        l--;
        r--;

        if (type == 1) {
            int t;
            cin >> t;

            update(1, 0, n - 1, l, r, t, 1);
        } else {
            map<int, pair<int, int>> answer = query(1, 0, n - 1, l, r);
            bool ok = true;

            for (auto &i : answer) {
                if (i.second.first != i.second.second) {
                    ok = false;
                    break;
                }
            }

            cout << ok << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}
