#include<iostream>
#include<algorithm>
#include<utility>
#include<vector>
#include<set>
using namespace std;

//lazy segment tree with interval min and max quarry
struct segm_tree{

    struct node{
        int min,max,lazy;
        node(): min{0},max{0},lazy{0}{}

    };

    int len;
    node * a;

    segm_tree(int length){
        a = new node[4*length];
        len=length;
        return;
    }

    void push(int c){
        a[2*c+1].min+=a[c].lazy;
        a[2*c+1].max+=a[c].lazy;
        a[2*c+1].lazy+=a[c].lazy;
        a[2*c+2].min+=a[c].lazy;
        a[2*c+2].max+=a[c].lazy;
        a[2*c+2].lazy+=a[c].lazy;
        a[c].lazy=0;
        return;
    }

    void update_node(int c){
        a[c].min=min(a[2*c+1].min,a[2*c+2].min);
        a[c].max=max(a[2*c+1].max,a[2*c+2].max);
        return;
    }

    void upd(int upd_v,int upd_l,int upd_r,int i,int l,int r){
        //cout<<"Info update: "<<i<<endl;
        if(l==upd_l and r==upd_r){
            a[i].lazy+=upd_v;
            a[i].min+=upd_v;
            a[i].max+=upd_v;
            return;
        }
        int m=(l+r)/2;
        push(i);
        if(upd_r<=m){
            upd(upd_v,upd_l,upd_r,2*i+1,l,m);
            update_node(i);
            return;
        }
        if(m<upd_l){
            upd(upd_v,upd_l,upd_r,2*i+2,m+1,r);
            update_node(i);
            return;
        }
        upd(upd_v,upd_l,m,2*i+1,l,m);
        upd(upd_v,m+1,upd_r,2*i+2,m+1,r);
        update_node(i);
        return;
    }

    //min,max
    pair<int,int> fin(int q_l,int q_r,int i,int l,int r){
        if(q_l==l and q_r==r){
            return {a[i].min,a[i].max};
        }
        int m=(l+r)/2;
        push(i);
        if(q_r<=m){
            return fin(q_l,q_r,2*i+1,l,m);
        }
        if(m<q_l){
            return fin(q_l,q_r,2*i+2,m+1,r);
        }
        pair<int,int> r1,r2;
        r1=fin(q_l,m,2*i+1,l,m);
        r2=fin(m+1,q_r,2*i+2,m+1,r);
        return {min(r1.first,r2.first),max(r1.second,r2.second)};
    }

    // 0 if not ; 1 if true
    bool find_equal(int lq,int rq){
        pair<int,int> t = fin(lq,rq,0,0,len-1);
        return t.first==t.second;
    }

    void add(int v,int lq,int rq){
        upd(v,lq,rq,0,0,len-1);
    }

};

//    segm_tree seg(8);
//    seg.upd(2,1,1,0,0,seg.len-1);
//    pair<int,int> t = seg.fin(1,7,0,0,seg.len-1);
//    cout<<"Info : "<<t.first<<" "<<t.second<<endl;
//    segm_tree seg(8);
//    seg.upd(2,1,1,0,0,seg.len-1);
//    cout<<seg.find_equal(1,1);




const int Max_N=200100;
const int Max_Q=200100;
const int Max_X=100100;

struct query{
    bool type;
    int f,s,t;
};

int n,q;
query que [Max_Q];

int num_x;
int which_is_compr [Max_N];
set<int> com;

void cin_quaries(){
    cin>>n>>q;
    int typ;
    int a,b,c;
    query qu;
    for(int i=0;i<q;i++){
        cin>>typ;
        if(typ==1){
            cin>>a>>b>>c;
            a--;
            b--;
            c--;
            qu.type=false;
            qu.f=a;
            qu.s=b;
            qu.t=c;
        }else{
            cin>>a>>b;
            a--;
            b--;
            qu.type=true;
            qu.f=a;
            qu.s=b;
        }
        que[i]=qu;
    }
    for(int i=0;i<q;i++){
        if(!que[i].type){
            //cout<<"Inserting : "<<que[i].t<<endl;
            com.insert(que[i].t);
        }
    }
    num_x=0;
    for(auto it = com.begin();it!=com.end();it++){
        //cout<<"Now at : "<<*it<<endl;
        which_is_compr[(*it)]=num_x;
        num_x++;
    }
    for(int i=0;i<q;i++){
        if(!que[i].type){
            //cout<<"Used to be : "<<que[i].t<<endl;
            que[i].t=which_is_compr[que[i].t];
            //cout<<"Now it is : "<<que[i].t<<endl;
        }
    }
    //cout<<"Num x : "<<num_x<<endl;
    return;
}



void stupid_solution(){
    vector< vector<int> > cups;
    cups.resize(n);
    for(int i=0;i<n;i++){
        cups[i].resize(num_x+1);
    }
    for(int counter=0;counter<q;counter++){
        if(que[counter].type){
            for(int i=que[counter].f;i<=que[counter].s;i++){
                for(int j=0;j<num_x;j++){
                    if(cups[i][j]!=cups[que[counter].f][j]){
                        cout<<"0"<<endl;
                        goto end_for;
                    }
                }
            }
            cout<<"1"<<endl;
            end_for:;
        }else{
            for(int i=que[counter].f;i<=que[counter].s;i++){
                cups[i][que[counter].t]++;
            }
        }
    }
    return;
}

void solution_5(){
    segm_tree seg(n);
    query curr;
    for(int q_i=0;q_i<q;q_i++){
        curr=que[q_i];
        if(curr.type){
            cout<<seg.find_equal(curr.f,curr.s)<<endl;
        }else{
            seg.add(1,curr.f,curr.s);
        }
    }
    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin_quaries();
    if(num_x==1){
        solution_5();
        return 0;
    }
    stupid_solution();
    return 0;
}
