#include<iostream>
#include<algorithm>
#include<utility>
#include<vector>
#include<set>
#include<cstdlib>
#include<ctime>
using namespace std;

//lazy segment tree with interval min and max quarry
struct segm_tree{

    struct node{
        int min,max,lazy;
        node(): min{0},max{0},lazy{0}{}

    };

    int len;
    node * a;

    segm_tree(int length){
        a = new node[4*length];
        len=length;
        return;
    }

    void push(int c){
        a[2*c+1].min+=a[c].lazy;
        a[2*c+1].max+=a[c].lazy;
        a[2*c+1].lazy+=a[c].lazy;
        a[2*c+2].min+=a[c].lazy;
        a[2*c+2].max+=a[c].lazy;
        a[2*c+2].lazy+=a[c].lazy;
        a[c].lazy=0;
        return;
    }

    void update_node(int c){
        a[c].min=min(a[2*c+1].min,a[2*c+2].min);
        a[c].max=max(a[2*c+1].max,a[2*c+2].max);
        return;
    }

    void upd(int upd_v,int upd_l,int upd_r,int i,int l,int r){
        //cout<<"Info update: "<<i<<endl;
        if(l==upd_l and r==upd_r){
            a[i].lazy+=upd_v;
            a[i].min+=upd_v;
            a[i].max+=upd_v;
            return;
        }
        int m=(l+r)/2;
        push(i);
        if(upd_r<=m){
            upd(upd_v,upd_l,upd_r,2*i+1,l,m);
            update_node(i);
            return;
        }
        if(m<upd_l){
            upd(upd_v,upd_l,upd_r,2*i+2,m+1,r);
            update_node(i);
            return;
        }
        upd(upd_v,upd_l,m,2*i+1,l,m);
        upd(upd_v,m+1,upd_r,2*i+2,m+1,r);
        update_node(i);
        return;
    }

    //min,max
    pair<int,int> fin(int q_l,int q_r,int i,int l,int r){
        if(q_l==l and q_r==r){
            return {a[i].min,a[i].max};
        }
        int m=(l+r)/2;
        push(i);
        if(q_r<=m){
            return fin(q_l,q_r,2*i+1,l,m);
        }
        if(m<q_l){
            return fin(q_l,q_r,2*i+2,m+1,r);
        }
        pair<int,int> r1,r2;
        r1=fin(q_l,m,2*i+1,l,m);
        r2=fin(m+1,q_r,2*i+2,m+1,r);
        return {min(r1.first,r2.first),max(r1.second,r2.second)};
    }

    // 0 if not ; 1 if true
    bool find_equal(int lq,int rq){
        pair<int,int> t = fin(lq,rq,0,0,len-1);
        return t.first==t.second;
    }

    void add(int v,int lq,int rq){
        upd(v,lq,rq,0,0,len-1);
    }

};

//    segm_tree seg(8);
//    seg.upd(2,1,1,0,0,seg.len-1);
//    pair<int,int> t = seg.fin(1,7,0,0,seg.len-1);
//    cout<<"Info : "<<t.first<<" "<<t.second<<endl;
//    segm_tree seg(8);
//    seg.upd(2,1,1,0,0,seg.len-1);
//    cout<<seg.find_equal(1,1);


// treap

struct treap{

    static const int Inf=999999;
    static const int m_Inf=-999999;

    struct node{
        int v,col,y;
        node * l,* r;

        node(int val):v{val},col{-1},y{rand()},l{nullptr},r{nullptr}{}
        
        node(int val,int co):v{val},col{co},y{rand()},l{nullptr},r{nullptr}{}
        
    };

    void update(node * c){
        return;
    }

    node * r;

    treap(int nn){
        srand(time(NULL));
        r = new node(0);
        r->y=Inf;
        r->col=-1;
        node * ll = new node(nn);
        ll->y=m_Inf;
        ll->col=-1;
        r->l=ll;
        return;
    }

    pair<node *,node *> split(int s_v,node * c){
        if(!c){
            return {nullptr,nullptr};
        }
        if(s_v<c->v){
            auto t = split(s_v,c->l);
            c->l=t.second;
            update(c);
            return {t.first,c};
        }
        if(s_v>c->v){
            auto t = split(s_v,c->r);
            c->r=t.first;
            update(c);
            return {c,t.second};
        }
        pair<node *,node *> t={c->l,c->r};
        delete c;
        return t;
    }

    node * mer(node * l,node * r){
        if(!l){
            return r;
        }
        if(!r){
            return l;
        }
        if(l->y<r->y){
            r->l=mer(l,r->l);
            update(r);
            return r;
        }else{
            l->r=mer(l->r,r);
            update(l);
            return l;
        }
    }

    void ins(int v,int co){
        auto t = split(v,r);
        mer(t.first,mer(new node(v,co),t.second));
    }

    int find_el(int val,node * c){
        if(!c){
            return -1;
        }
        if(c->v==val){
            return c->col;
        }
        if(val<c->v){
            return find_el(val,c->l);
        }else{
            return find_el(val,c->r);
        }
    }

    pair<int,int> find_near(int val,node * c,int sm,int la){
        if(!c){
            return {sm,la};
        }
        if(val==c->v){
            return {val,val};
        }
        if(val<c->v){
            return find_near(val,c->l,sm,min(la,c->v));
        }else{
            return find_near(val,c->r,max(sm,c->v),la);
        }
    }
    
    void del(int v){
        auto t = split(v);
        mer(t.first,t.second);
        return;
    }

};


//    treap tr;
//    tr.ins(15);
//    tr.ins(8);
//    tr.ins(10);
//    auto t = tr.find_near(10,tr.r,0,30);
//    cout<<tr.find_el(14,tr.r)<<endl;
//    cout<<t.first<<" "<<t.second<<endl;


//



const int Max_N=200100;
const int Max_Q=200100;
const int Max_X=100100;

struct query{
    bool type;
    int f,s,t;
};

int n,q;
query que [Max_Q];

int num_x;
int which_is_compr [Max_N];
set<int> com;

void cin_quaries(){
    cin>>n>>q;
    int typ;
    int a,b,c;
    query qu;
    for(int i=0;i<q;i++){
        cin>>typ;
        if(typ==1){
            cin>>a>>b>>c;
            a--;
            b--;
            c--;
            qu.type=false;
            qu.f=a;
            qu.s=b;
            qu.t=c;
        }else{
            cin>>a>>b;
            a--;
            b--;
            qu.type=true;
            qu.f=a;
            qu.s=b;
        }
        que[i]=qu;
    }
    for(int i=0;i<q;i++){
        if(!que[i].type){
            //cout<<"Inserting : "<<que[i].t<<endl;
            com.insert(que[i].t);
        }
    }
    num_x=0;
    for(auto it = com.begin();it!=com.end();it++){
        //cout<<"Now at : "<<*it<<endl;
        which_is_compr[(*it)]=num_x;
        num_x++;
    }
    for(int i=0;i<q;i++){
        if(!que[i].type){
            //cout<<"Used to be : "<<que[i].t<<endl;
            que[i].t=which_is_compr[que[i].t];
            //cout<<"Now it is : "<<que[i].t<<endl;
        }
    }
    //cout<<"Num x : "<<num_x<<endl;
    return;
}



void stupid_solution(){
    vector< vector<int> > cups;
    cups.resize(n);
    for(int i=0;i<n;i++){
        cups[i].resize(num_x+1);
    }
    for(int counter=0;counter<q;counter++){
        if(que[counter].type){
            for(int i=que[counter].f;i<=que[counter].s;i++){
                for(int j=0;j<num_x;j++){
                    if(cups[i][j]!=cups[que[counter].f][j]){
                        cout<<"0"<<endl;
                        goto end_for;
                    }
                }
            }
            cout<<"1"<<endl;
            end_for:;
        }else{
            for(int i=que[counter].f;i<=que[counter].s;i++){
                cups[i][que[counter].t]++;
            }
        }
    }
    return;
}




void solution_4(){
    treap my_tr(n);
    query curr;
    for(int q_i=0;q_i<q;q_i++){
        curr=que[q_i];
        if(curr.type){
            pair<int,int> t1,t2,t3;
            t1=my_tr.find_near(curr.f,my_tr.r,0,n);
            t2=my_tr.find_near(curr.s,my_tr.r,0,n);
            if(t1.first==t1.second and t2.first==t2.second){
                t3=my_tr.find_near(curr.s,my_tr.r,0,n);
                if(){
                    
                }
            }
            if(t1.first==t1.second){
                if(t1.first==t2.first or t1.first==t2.second){
                    cout<<"1"<<endl;
                    goto end_part_solution_4;
                }else{
                    cout<<"0"<<endl;
                    goto end_part_solution_4;
                }
            }
            if(t2.first==t2.second){
                if(t2.first==t1.first or t2.first==t1.second){
                    cout<<"1"<<endl;
                    goto end_part_solution_4;
                }else{
                    cout<<"0"<<endl;
                    goto end_part_solution_4;
                }
            }
            if(){
                
            }
            end_part_solution_4:;
        }else{
            my_tr.ins(curr.f,curr.t);
            auto tt=my_tr.find_near(curr.s+1,my_tr.r,0,n);
            if(curr.t==my_tr.find_el(tt.first,my_tr.r)){
                my_tr.del(tt.first);
            }
            my_tr.ins(curr.s,curr.t);
            auto tp=my_tr.find_near(curr.f-1,my_tr.r,0,n);
            if(curr.t==my_tr.find_el(tp.second,my_tr.r)){
                my_tr.del(tt.second);
            }
        }
    }
    return;
}

void solution_5(){
    segm_tree seg(n);
    query curr;
    for(int q_i=0;q_i<q;q_i++){
        curr=que[q_i];
        if(curr.type){
            cout<<seg.find_equal(curr.f,curr.s)<<endl;
        }else{
            seg.add(1,curr.f,curr.s);
        }
    }
    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin_quaries();
    if(num_x==1){
        solution_5();
        return 0;
    }else{
        if(n>3000 or q>3000){
            solution_4();
        }
    }
    stupid_solution();
    return 0;
}
