#include <bits/stdc++.h>

using namespace std;

typedef unsigned long long ull;
const int N = 2e5 + 3;
const int T = 1e5;
int n, q;
ull num[N];
mt19937_64 mt(79);

struct SegmentTree{
    struct Node{
        bool eq;
        ull num;

        Node(){
            eq = true;
            num = 0;
        }

        friend Node merge(const Node &l, const Node &r){
            Node ret;
            if(l.eq && r.eq && l.num == r.num){
                ret.eq = true;
                ret.num = l.num;
            }
            else ret.eq = false;
            return ret;
        }
    };
    Node nd[4 * N];
    ull lp[4 * N];

    void push(int i, int l, int r){
        if(!lp[i]) return;
        nd[i].num += lp[i];
        if(l != r){
            lp[2 * i + 1] += lp[i];
            lp[2 * i + 2] += lp[i];
        }
        lp[i] = 0;
    }

    void update(int l2, int r2, ull add, int i = 0, int l = 1, int r = n){
        push(i, l, r);
        if(r2 < l || r < l2) return;
        if(l2 <= l && r <= r2){
            lp[i] += add;
            push(i, l, r);
            return;
        }

        int mid = (l + r) >> 1;
        update(l2, r2, add, 2 * i + 1, l, mid);
        update(l2, r2, add, 2 * i + 2, mid + 1, r);
        nd[i] = merge(nd[2 * i + 1], nd[2 * i + 2]);
    }

    Node query(int l2, int r2, int i = 0, int l = 1, int r = n){
        push(i, l, r);
        if(l2 <= l && r <= r2) return nd[i];
        int mid = (l + r) >> 1;
        if(l2 <= mid){
            if(r2 >= mid + 1)
                return merge(query(l2, r2, 2 * i + 1, l, mid), query(l2, r2, 2 * i + 2, mid + 1, r));
            return query(l2, r2, 2 * i + 1, l, mid);
        }
        return query(l2, r2, 2 * i + 2, mid + 1, r);
    }
} st;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> q;
    for(int i = 1; i <= T; ++i)
        while(!num[i])
            num[i] = mt();

    for(int i = 0; i < q; ++i){
        int t;
        cin >> t;

        if(t == 1){
            int l, r, x;
            cin >> l >> r >> x;
            st.update(l, r, x);
        }
        else{
            int l, r;
            cin >> l >> r;
            cout << st.query(l, r).eq << "\n";
        }
    }
}
