#include "periods.h"

using namespace std;

bool hasPeriod (int len, int period);
const int N = 1e5 + 3;

int big_prime[N];

void sieve(){
    for(int i = 2; i < N; ++i)
        if(!big_prime[i])
            for(int j = i; j < N; j += i)
                big_prime[j] = i;
}

vector<int> findPeriods(int n){
    sieve();

    vector<int> ans(n);
    ans[0] = 1;
    for(int i = 1; i < n; ++i){
        int len = i + 1;
        int len2 = len;

        int curr = 1;
        while(len2 != 1){
            int p = big_prime[len2], p2 = 1;
            bool ok = true;
            while(len2 % p == 0){
                len2 /= p;
                p2 *= p;
                if(ok && ans[i - len / p2] % (p2 - 1) == 0 && hasPeriod(len, len / p2))
                    curr *= p;
                else ok = false;
            }
        }
        ans[i] = curr;
    }

    for(int i = 0; i < n; ++i){
        int len = i + 1;
        ans[i] = len / ans[i];
    }
    return ans;
}

