#include "periods.h"

using namespace std;

bool hasPeriod (int len, int period);
const int N = 1e5 + 3;

int big_prime[N];

void sieve(){
    for(int i = 2; i < N; ++i)
        if(!big_prime[i])
            for(int j = i; j < N; j += i)
                big_prime[j] = i;
}

vector<int> findPeriods(int n){
    sieve();

    vector<int> ans(n);
    for(int i = 0; i < n; ++i)
        ans[i] = i + 1;
    for(int i = 1; i <= n / 2; ++i){
        int l = 1, r = n / i;
        while(l <= r && ans[l * i - 1] < i)
            ++l;
        while(l != r){
            int mid = (l + r + 1) >> 1;
            if(hasPeriod(mid * i, i)) l = mid;
            else r = mid - 1;
        }
        for(int j = i - 1; j < l * i; j += i)
            ans[j] = min(ans[j], i);
    }
    return ans;
}
