#include "periods.h"

using namespace std;

bool hasPeriod (int len, int period);
const int N = 1e5 + 3;

int big_prime[N];

void sieve(){
    for(int i = 2; i < N; ++i)
        if(!big_prime[i])
            for(int j = i; j < N; j += i)
                big_prime[j] = i;
}

vector<int> findPeriods(int n){
    sieve();

    vector<int> ans(n);
    for(int i = 0; i < n; ++i)
        ans[i] = i + 1;
    int curr = 0;
    for(int i = 1; i <= n / 2; ++i){
        curr %= i;
        if(curr == 0) curr = i;
        ans[curr - 1] = min(ans[curr - 1], i);

        while(curr + i <= n && hasPeriod(curr + i, i)){
            curr += i;
            ans[curr - i] = min(ans[curr - 1], i);
        }
    }
    return ans;
}
