#include "periods.h"
#include <iostream>

using namespace std;

bool hasPeriod (int len, int period);
const int N = 1e5 + 3;

int big_prime[N];

void sieve(){
    for(int i = 2; i < N; ++i)
        if(!big_prime[i])
            for(int j = i; j < N; j += i)
                big_prime[j] = i;
}

vector<int> findPeriods(int n){
    sieve();

    vector<int> ans(n);
    for(int i = 0; i < n; ++i)
        ans[i] = i + 1;
    int i = 1;
    while(i <= n / 2){
        if(hasPeriod(2 * i, i)){
            ans[2 * i - 1] = i;
            int new_i = 2 * i;
            int l = 2, r = n / i;
            while(l < r){
                //cout << l << " " << r << endl;
                int mid = (l + r + 1) >> 1;
                if(hasPeriod(mid * i, i)) l = mid;
                else r = mid - 1;
            }
            for(int j = 3; j <= l; ++j)
                ans[j * i - 1] = i;
            new_i = l * i;
            /*
            for(int j = 3; j * i <= n; ++j){
                if(hasPeriod(j * i, i)){
                    ans[j * i - 1] = i;
                    new_i = j * i;
                }
                else break;
            }
            */
            i = new_i + 1;
        }
        else ++i;
    }
    return ans;
}
