#include <iostream>
#include <set>
#include <utility>
using namespace std;

const int MAXN = 200005;

int n, q;
multiset<int> ms[MAXN];
set<pair<int, int>> seg;

void splitmerge(int idx)
{
    auto iter = --seg.upper_bound(make_pair(idx, n + 1));

    if (idx == (*iter).first)
    {
        if (ms[idx] == ms[idx - 1])
        {
            int r = (*iter).second;
            int l = (*(--iter)).first;
            iter = seg.erase(iter);
            seg.erase(iter);
            seg.emplace(make_pair(l, r));
        }
    }
    else // if (idx != (*iter).first)
    {
        int l = (*iter).first;
        int r = (*iter).second;
        seg.erase(iter);
        seg.emplace(l, idx - 1);
        seg.emplace(idx, r);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;
    seg.emplace(1, n);

    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t;

        if (t == 1)
        {
            int l, r, x;
            cin >> l >> r >> x;
            for (int i = l; i <= r; ++ i)
            {
                ms[i].insert(x);
            }

            if (l != 1) splitmerge(l);
            if (r != n) splitmerge(r + 1);

            /*{
                cout << "-----------" << endl;
                for (auto ele : seg)
                {
                    cout << ele.first << ' ' << ele.second << endl;
                }
                cout << "-----------" << endl;
            }*/

        }
        if (t == 2)
        {
            int l, r;
            cin >> l >> r;
            auto iter = --seg.upper_bound(make_pair(l, n + 1));
            if ((*iter).second >= r) cout << 1 << endl;
            else cout << 0 << endl;
        }
    }
}

/*
4 7
2 1 3
1 1 3 5
1 3 4 6
2 1 3
2 1 2
1 2 2 5
2 1 1
*/
