#include <iostream>
#include <set>
#include <map>
#include <utility>
using namespace std;

const int MAXN = 200005;

int n, q;
map<int, multiset<int>> mpms; /// key -> multiset
set<pair<pair<int, int>, int>> seg; /// interval, key

int key_counter = 0;

void split(int idx)
{
    auto iter = --seg.upper_bound({make_pair(idx, n + 1), 0});

    if (idx != (*iter).first.first)
    {
        int l = (*iter).first.first;
        int r = (*iter).first.second;
        int key = (*iter).second;
        seg.erase(iter);
        seg.insert({{l, idx - 1}, key});
        seg.insert({{idx, r}, ++key_counter});
        mpms[key_counter] = mpms[key]; // clone the existing set into new one
    }
}

void merge(int idx)
{
    auto iter = --seg.upper_bound({make_pair(idx, n + 1), 0});

    if (idx == (*iter).first.first)
    {
        int rightkey = (*iter).second;
        int leftkey = (*(--iter)).second;
        iter++;

        //cout << "key " << leftkey << ' ' << rightkey << endl;

        if (mpms[rightkey] == mpms[leftkey])
        {


            int r = (*iter).first.second;
            int l = (*(--iter)).first.first;

           // cout << "merging " << l << ' ' << r << endl;
            iter = seg.erase(iter);
            seg.erase(iter);
            seg.emplace(make_pair(l, r), rightkey);
            mpms[leftkey] = {};
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;
    seg.emplace(make_pair(1, n), ++key_counter);
    mpms[key_counter] = {};

    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t;

        if (t == 1)
        {
            int l, r, x;
            cin >> l >> r >> x;

            if (l != 1) split(l);
            if (r != n) split(r + 1);

            /*{
                cout << "-----------" << endl;
                for (auto ele : seg)
                {
                    cout << ele.first.first << ' ' << ele.first.second << ' ' << ele.second << endl;
                    cout << "content: ";
                    for (int x : mpms[ele.second]) cout << x << ' ';
                    cout << endl;
                }
                cout << "-----------" << endl;
            }//*/

            auto iter = --seg.upper_bound({make_pair(l, n + 1), 0});
            while ((*iter).first.first <= r and iter != seg.end())
            {
                int key = (*iter).second;
                mpms[key].insert(x);


                //cout << "adding x to " << (*iter).first.first << ' ' << (*iter).first.second << " with key " << (*iter).second << endl;

                iter++;
            }

            if (l != 1) merge(l);
            if (r != n) merge(r + 1);

            /*{
                cout << "-----------" << endl;
                for (auto ele : seg)
                {
                    cout << ele.first.first << ' ' << ele.first.second << ' ' << ele.second << endl;
                    cout << "content: ";
                    for (int x : mpms[ele.second]) cout << x << ' ';
                    cout << endl;
                }
                cout << "-----------" << endl;
            }//*/
        }
        if (t == 2)
        {
            int l, r;
            cin >> l >> r;
            auto iter = --seg.upper_bound({make_pair(l, n + 1), 0});
            if ((*iter).first.second >= r) cout << 1 << endl;
            else cout << 0 << endl;
        }
    }
}

/*
4 7
2 1 3
1 1 3 5
1 3 4 6
2 1 3
2 1 2
1 2 2 5
2 1 1
*/
