#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 200005;

struct node
{
    long long frsz, bksz, frvl, bkvl, lazy;
};

int n, q;
node tree[MAXN * 4];
vector<int> primes;
bool e[4000006];

void push_lazy(int v, int l, int r)
{
    if (tree[v].lazy != 0)
    {
        tree[v].frvl += tree[v].lazy;
        tree[v].bkvl += tree[v].lazy;

        if (l != r)
        {
            tree[v << 1 | 0].lazy += tree[v].lazy;
            tree[v << 1 | 1].lazy += tree[v].lazy;
        }

        tree[v].lazy = 0;
    }
}

void build(int v = 1, int l = 1, int r = n)
{
    tree[v].frvl = tree[v].bkvl = 0;
    tree[v].frsz = tree[v].bksz = r - l + 1;
    tree[v].lazy = 0;

    if (l != r)
    {
        int mid = (l + r) >> 1;
        build(v << 1 | 0, l, mid + 0);
        build(v << 1 | 1, mid + 1, r);
    }
}

int le, ri, delta;
void update(int v = 1, int l = 1, int r = n)
{
    push_lazy(v, l, r);

    if (r < le or ri < l) return;
    if (le <= l and r <= ri)
    {
        tree[v].lazy += delta;
        push_lazy(v, l, r);
        return;
    }

    int mid = (l + r) >> 1;
    update(v << 1 | 0, l, mid + 0);
    update(v << 1 | 1, mid + 1, r);

    // combine

    int leftlen = mid - l + 1;
    int rightlen = r - mid;

    if (tree[v << 1 | 0].frsz == leftlen and tree[v << 1 | 0].frvl == tree[v << 1 | 1].frvl)
    {
        tree[v].frvl = tree[v << 1 | 0].frvl;
        tree[v].frsz = leftlen + tree[v << 1 | 1].frsz;
    }
    else
    {
        tree[v].frvl = tree[v << 1 | 0].frvl;
        tree[v].frsz = tree[v << 1 | 0].frsz;
    }

    if (tree[v << 1 | 1].bkvl == rightlen and tree[v << 1 | 1].bkvl == tree[v << 1 | 0].bkvl)
    {
        tree[v].bkvl = tree[v << 1 | 1].bkvl;
        tree[v].bksz = rightlen + tree[v << 1 | 0].bksz;
    }
    else
    {
        tree[v].bkvl = tree[v << 1 | 1].bkvl;
        tree[v].bksz = tree[v << 1 | 0].bksz;
    }
}

int ok = 1, val = -1;
void query(int v = 1, int l = 1, int r = n)
{
    push_lazy(v, l, r);

    if (ri < l or r < le) return;
    if (le <= l and r <= ri)
    {
        int len = r - l + 1;
        if (tree[v].frsz != len) ok = 0;
        if (val == -1) val = tree[v].frvl;
        else if (tree[v].frvl != val) ok = 0;
        return;
    }

    int mid = (l + r) >> 1;
    query(v << 1 | 0, l, mid + 0);
    query(v << 1 | 1, mid + 1, r);
}

void Erat()
{
    for (int i = 2; i < 4000000; ++ i)
    {
        if (e[i] == 0)
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j < 1000000; j += i)
            {
                e[j] = 1;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    Erat();

    // cout << primes.size() << endl;

    cin >> n >> q;

    build();
    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t;

        if (t == 1)
        {
            int l, r, x;
            cin >> l >> r >> x;
            le = l; ri = r;
            delta = primes[primes.size() - 1 - x];
            update();
        }
        if (t == 2)
        {
            int l, r;
            cin >> l >> r;
            le = l;
            ri = r;
            ok = 1;
            val = -1;
            query();
            cout << ok << endl;
        }
    }

    return 0;
}

/*
4 7
2 1 3
1 1 3 1
1 3 4 1
2 1 3
2 1 2
1 2 2 1
2 1 2
*/
