#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 200005;
const int DIM = 3;

struct node
{
    long long frsz[DIM], bksz[DIM], frvl[DIM], bkvl[DIM], lazy[DIM];
};

int n, q;
node tree[MAXN * 4];
vector<int> primes;
bool e[4000006];

void push_lazy(int v, int l, int r, int i)
{
    if (tree[v].lazy[i] != 0)
    {
        tree[v].frvl[i] += tree[v].lazy[i];
        tree[v].bkvl[i] += tree[v].lazy[i];

        if (l != r)
        {
            tree[v << 1 | 0].lazy[i] += tree[v].lazy[i];
            tree[v << 1 | 1].lazy[i] += tree[v].lazy[i];
        }

        tree[v].lazy[i] = 0;
    }
}

void build(int i, int v = 1, int l = 1, int r = n)
{
    tree[v].frvl[i] = tree[v].bkvl[i] = 0;
    tree[v].frsz[i] = tree[v].bksz[i] = r - l + 1;
    tree[v].lazy[i] = 0;

    if (l != r)
    {
        int mid = (l + r) >> 1;
        build(i, v << 1 | 0, l, mid + 0);
        build(i, v << 1 | 1, mid + 1, r);
    }
}

int le, ri, delta[DIM];
void update(int i, int v = 1, int l = 1, int r = n)
{
    push_lazy(v, l, r, i);

    if (r < le or ri < l) return;
    if (le <= l and r <= ri)
    {
        tree[v].lazy[i] += delta[i];
        push_lazy(v, l, r, i);
        return;
    }

    int mid = (l + r) >> 1;
    update(i, v << 1 | 0, l, mid + 0);
    update(i, v << 1 | 1, mid + 1, r);

    // combine

    int leftlen = mid - l + 1;
    int rightlen = r - mid;

    if (tree[v << 1 | 0].frsz[i] == leftlen and tree[v << 1 | 0].frvl[i] == tree[v << 1 | 1].frvl[i])
    {
        tree[v].frvl[i] = tree[v << 1 | 0].frvl[i];
        tree[v].frsz[i] = leftlen + tree[v << 1 | 1].frsz[i];
    }
    else
    {
        tree[v].frvl[i] = tree[v << 1 | 0].frvl[i];
        tree[v].frsz[i] = tree[v << 1 | 0].frsz[i];
    }

    if (tree[v << 1 | 1].bkvl[i] == rightlen and tree[v << 1 | 1].bkvl[i] == tree[v << 1 | 0].bkvl[i])
    {
        tree[v].bkvl[i] = tree[v << 1 | 1].bkvl[i];
        tree[v].bksz[i] = rightlen + tree[v << 1 | 0].bksz[i];
    }
    else
    {
        tree[v].bkvl[i] = tree[v << 1 | 1].bkvl[i];
        tree[v].bksz[i] = tree[v << 1 | 0].bksz[i];
    }
}

int ok = 1, val = -1;
void query(int i, int v = 1, int l = 1, int r = n)
{
    push_lazy(v, l, r, i);

    if (ri < l or r < le) return;
    if (le <= l and r <= ri)
    {
        int len = r - l + 1;
        if (tree[v].frsz[i] != len) ok = 0;
        if (val == -1) val = tree[v].frvl[i];
        else if (tree[v].frvl[i] != val) ok = 0;
        return;
    }

    int mid = (l + r) >> 1;
    query(i, v << 1 | 0, l, mid + 0);
    query(i, v << 1 | 1, mid + 1, r);
}

void Erat()
{
    for (int i = 2; i < 4000000; ++ i)
    {
        if (e[i] == 0)
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j < 1000000; j += i)
            {
                e[j] = 1;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    Erat();

    // cout << primes.size() << endl;

    cin >> n >> q;

    for (int i = 0; i < DIM; ++ i) build(i);
    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t;

        if (t == 1)
        {
            int l, r, x;
            cin >> l >> r >> x;
            le = l; ri = r;
            delta[0] = primes[primes.size() - 1 - x];
            delta[1] = primes[primes.size() - 2 - x];
            delta[2] = primes[primes.size() - 3 - x];
            for (int j = 0; j < DIM; ++ j) update(j);
        }
        if (t == 2)
        {
            int l, r;
            cin >> l >> r;
            le = l;
            ri = r;
            bool flag = 1;
            for (int j = 0; j < DIM; ++ j)
            {
                ok = 1;
                val = -1;
                query(j);
                if (ok == 0)
                {
                    cout << 0 << endl;
                    flag = 0;
                    break;
                }
            }
            if (flag == 1) cout << ok << endl;
        }
    }

    return 0;
}

/*
4 7
2 1 3
1 1 3 1
1 3 4 1
2 1 3
2 1 2
1 2 2 1
2 1 2
*/
