#include "periods.h"
// #include "Lgrader.cpp"
#include <algorithm>
using namespace std;

std::vector<int> findPeriods(int n)
{
    vector<int> periods;
    for (int i = 1; i <= n; ++ i)
    {
        periods.push_back(i);
    }

    for (int i = 2; i <= n; ++ i)
    {
        vector<int> div;
        for (int j = 1; j * j <= i; ++ j)
        {
            if (j * j == i)
            {
                div.push_back(j);
            }
            else if (i % j == 0)
            {
                div.push_back(j);
                div.push_back(i / j);
            }
        }
        sort(div.begin(), div.end());

        /*cout << "divisors of " << i << ": ";
        for (int j = 0; j < div.size(); ++ j) cout << div[j] << ' ';
        cout << endl;*/

        bool updated = false;
        for (int j = 0; j < div.size() - 1; ++ j)
        {
            int pos = i - div[j] - 1;
            if (periods[pos] <= div[j] and periods[i - 1] > div[j])
            {
                //cout << "asking for " << i << ' ' << div[j] << endl;
                if (hasPeriod(i, div[j]))
                {
                    periods[i - 1] = div[j];
                    updated = true;
                    break;
                }
            }
        }

        // for small periods only
        if (1ll * periods[i - 1] * periods[i - 1] <= i and updated)
        {
            int lastidx = 0;
            for (int j = 1; true; j *= 2)
            {
                int pos = i + j * periods[i - 1] - 1;
                if (pos >= n) break;

                //cout << "asking for " << pos << ' ' << periods[i - 1] << endl;
                if (hasPeriod(pos, periods[i - 1]))
                {
                    lastidx = pos;
                }
                else break;
            }

            for (int j = i - 1; j <= lastidx; j += periods[i - 1])
            {
                periods[j] = min(periods[j], periods[i - 1]);
            }
        }
    }

    return periods;
}

/*
18
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
1 2 3 4 1 2 1 2 3 4 1 2 1 2 3 4 1 2
1 2 3 4 5 6 7 8 9 10 11 6 13 14 15 16 17 6
*/
