#include<bits/stdc++.h>
using namespace std;

int const maxn = 2*1e5 + 5;

struct Sg_tree
{
    vector<int>tree;
    vector<int>lazy;
    int n;

    Sg_tree(){}
    Sg_tree(int nn)
    {
        n = nn;
        tree.resize(n*8);
        lazy.resize(n*8);
    }

    void push_lazy(int k,int l,int r)
    {
        if(l == r)
        {
            tree[k] += lazy[k];
            lazy[k] = 0;
            return ;
        }

        if(tree[k] != -1)tree[k]+=lazy[k];
        lazy[k*2] += lazy[k];
        lazy[k*2+1] += lazy[k];
        lazy[k] = 0;

    }

    void real_update(int k,int l, int r, int x,int y)
    {
        if(lazy[k])push_lazy(k,l,r);
        if(x<=l && r<=y)
        {
            lazy[k] += 1;
            push_lazy(k,l,r);
            //cout<<k<<" "<<l<<" "<<r<<" : "<<tree[k] <<endl;
            return ;
        }

        if(r<x || l>y)
            return;


        real_update(k*2,l,(l+r)/2,x,y);
        real_update(k*2+1,(l+r)/2+1,r,x,y);

        if(tree[k*2] == tree[k*2+1]) tree[k] = tree[k*2];
        else tree[k] = -1;

        //cout<<k<<" "<<l<<" "<<r<<" : "<<tree[k] <<endl;
    }

    void update(int left, int right)
    {
        real_update(1,1,n,left,right);
    }

    int real_ans(int k,int l,int r,int x,int y)
    {
        if(lazy[k])push_lazy(k,l,r);
        if(x<=l && r<=y)
        {
            //cout<<k<<" "<<l<<" "<<r<<" : "<<tree[k] <<endl;
            return tree[k];
        }
        if(r<x || l>y)
            return -2;

        int left,right;
        left = real_ans(k*2,l,(l+r)/2,x,y);
        right = real_ans(k*2+1,(l+r)/2+1,r,x,y);

        //cout<<k<<" "<<l<<" "<<r<<" : "<<left<<" "<<right <<endl;
        if(left == -2)
            return right;
        if(right == -2)return left;

        if(left == right)return left;
        return -1;
    }

    int get_ans(int left, int right)
    {
        int ans = real_ans(1,1,n,left,right);
        if(ans == -1) return 0;
        else return 1;
    }
};

int n,q;
unordered_map<int,Sg_tree>T;
bool type[maxn];
vector<int>xi;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int q,i,t;
    cin>>n>>q;

    for(i=0; i<q; i++)
    {
        cin>>t;
        if(t == 1)
        {
            int l,r,x;
            cin>>l>>r>>x;
            if(!type[x])
            {
                xi.push_back(x);
                type[x] = true;
                T[x] = Sg_tree(n);
            }

            T[x].update(l,r);
        }

        else
        {
            int l,r;
            cin>>l>>r;

            int j,sz = xi.size();
            int ans = 1;
            for(j=0; j<sz; j++)
            {
                ans = min(T[xi[j]].get_ans(l,r),ans);
            }
            cout<<ans<<"\n";
        }
    }

    return 0;
}
