#include <functional>
#include <algorithm>
#include <iostream>
#include <vector>

#include "periods.h"
//#include "Lgrader.cpp"

using namespace std;

vector <int> getDivs(int x)
{
    if(x==1) return {};

    vector <int> divs;
    for(int d = 1;d*d<=x;d++)
    {
        if(x%d==0)
        {
            divs.push_back(d);
            if(x/d!=d && d!=1) divs.push_back(x/d);
        }
    }

    sort(divs.begin(), divs.end(), [&](int a, int b){return a>b;});
    return divs;
}

void optimizeperiods(int p, vector <int> &periods)
{
    //cout << p << ":";
    vector <int> v;
    for(int i = p;i<=periods.size();i+=p)
    {
        if(i%p!=0 || periods[i-1]!=-1) continue;
        v.push_back(i);

        //cout << " " << i;
    }
    //cout << '\n';

    int len = 0;
    for(int bit = 22;bit>=0;bit--)
    {
        if(len+(1<<bit)>v.size()) continue;

        bool fail = false;
        if(hasPeriod(v[len+(1<<bit)-1], p)==true) len += (1<<bit);
    }

    for(int i = 0;i<len;i++) periods[v[i]-1] = p;
}

vector<int> findPeriods(int n)
{
    int last = 1;
    vector <int> periods(n, -1);

    for(int p = 1;p<=n;p++) optimizeperiods(p, periods);

    return periods;
}
