#include <functional>
#include <algorithm>
#include <iostream>
#include <vector>

#include "periods.h"
//#include "Lgrader.cpp"

using namespace std;

vector <int> getDivs(int x)
{
    if(x==1) return {};

    vector <int> divs;
    for(int d = 1;d*d<=x;d++)
    {
        if(x%d==0)
        {
            divs.push_back(d);
            if(x/d!=d && d!=1) divs.push_back(x/d);
        }
    }

    sort(divs.begin(), divs.end(), [&](int a, int b){return a>b;});
    return divs;
}

vector<int> findPeriods(int n)
{
    int last = 1;
    vector <int> periods(n);

    for(int i = 1;i<=n;i++)
    {
        int ans = i;
        vector <int> divs = getDivs(i);

        //cout << i << ":";
        //for(int p: divs) cout << " " << p;
        //cout << '\n';

        //cout << " ---- " << i << " --- " << '\n';

        vector <int> failedPeriods;
        while(divs.size()>0)
        {
            //cout << ans << " -> " << failedPeriods.size() << " " << divs.back() << '\n';

            int p = divs.back();
            divs.pop_back();

            bool fail = false;
            for(int f: failedPeriods)
            {
                //cout << f << "/" << p << '\n';

                if(f%p==0)
                {
                    fail = true;
                    break;
                }
            }

            if(fail==true)
            {
                failedPeriods.push_back(p);
                continue;
            }
            if(i-p>=p && periods[i-1-p]>p)
            {
                failedPeriods.push_back(p);
                continue;
            }
            if(i-p>=p && (__gcd(periods[i-1-p], p)>1 && periods[i-1-p]!=p))
            {
                failedPeriods.push_back(p);
                continue;
            }

            if(hasPeriod(i, p)==true)
            {
                ans = p;
                divs = getDivs(p);

                break;
            }
            else
            {
                failedPeriods.push_back(p);
            }
        }

        periods[i-1] = ans;
    }

    return periods;
}
