#include <iostream>
using namespace std;
#define endl '\n'
const int MAXN=2e5+10;
const long long mod=1e9+7;
const long long p=1e6+7;
long long st[MAXN];
long long sum[4*MAXN], tree[4*MAXN], lazy[4*MAXN];
void build_tree(int node, int l, int r) {
    tree[node]=1;
    lazy[node]=sum[node]=0;
    if (l==r) return;
    int mid=(l+r)/2;
    build_tree(node*2,l,mid);
    build_tree(node*2+1,mid+1,r);
}
void push_lazy(int node, int l, int r) {
    if (l!=r) {
        lazy[node*2]=(lazy[node*2]+lazy[node])%mod;
        lazy[node*2+1]=(lazy[node*2+1]+lazy[node])%mod;
        sum[node*2]=(sum[node*2]+lazy[node]);
        sum[node*2+1]=(sum[node*2+1]+lazy[node])%mod;
        lazy[node]=0;
    }
}
void update(int node, int l, int r, int ql, int qr, int ch) {
    if (ql>r || qr<l) return;
    push_lazy(node,l,r);
    if (l>=ql && r<=qr) {
        lazy[node]=(lazy[node]+ch)%mod;
        sum[node]=(sum[node]+ch)%mod;
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,ql,qr,ch);
    update(node*2+1,mid+1,r,ql,qr,ch);
    if (tree[node*2]!=-1 && tree[node*2+1]!=-1 && sum[node*2]==sum[node*2+1]) {
        tree[node]=1;
        sum[node]=sum[node*2];
    }
    else tree[node]=-1;
    ///cout << "update " << l << ' ' << r << ' ' << sum[node*2] << ' ' << sum[node*2+1] << ' ' << sum[node] << endl;
}
int query(int node, int l, int r, int ql, int qr) {
    if (ql>r || qr<l) return -2;
    push_lazy(node,l,r);
    if (l>=ql && r<=qr) {
        if (tree[node]==-1) return -1;
        return sum[node];
    }
    int mid=(l+r)/2;
    int s1=query(node*2,l,mid,ql,qr);
    int s2=query(node*2+1,mid+1,r,ql,qr);
    ///cout << "query " << l << ' ' << r << ' ' << s1 << ' ' << s2 << endl;
    if (s1==-1 || s2==-1) return -1;
    if (s1==-2) return s2;
    else if (s2==-2) return s1;
    if (s1==s2) return s1;
    return -1;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q, type, l, r, x;
    cin >> n >> q;
    build_tree(1,1,n);
    st[1]=1;
    for (int i=2;i<=1e5;i++) st[i]=(st[i-1]*p)%mod;
    for (int i=0;i<q;i++) {
        cin >> type;
        if (type==1) {
            cin >> l >> r >> x;
            update(1,1,n,l,r,st[x]);
        } else {
            cin >> l >> r;
            int ans=query(1,1,n,l,r);
            if (ans==-1) cout << 0 << endl;
            else cout << 1 << endl;
        }
    }
    return 0;
}
/**
5 9
1 1 3 1
1 3 5 1
2 1 2
2 2 4
1 1 5 1
2 1 5
1 1 2 1
1 4 5 1
2 1 5
**/
