#include<iostream>
#include<vector>

#include "periods.h"

using namespace std;

vector<vector<int>> erathosten(int n) {
    vector<int> not_prime(n + 3, false);
    not_prime[0] = not_prime[1] = true;

    vector<vector<int>> res(n + 3, {1});
    res[2].push_back(2);
    for (int i = 4; i <= n; i += 2) {
        res[i].push_back(2);
        not_prime[i] = true;
    }

    for (int i = 3; i <= n; i += 2) {
        res[i].push_back(i);
        if (not_prime[i]) {
           continue;
        }

        for (int j = 2 * i; j <= n; j += i) {
            res[j].push_back(i);
            not_prime[j] = true;
        }
    }

    for (int i = 2; i <= n; ++i) {
        res[i].push_back(i);
    }

    return res;
}

vector<int> findPeriods(int n) {
    vector<vector<int>> divs = erathosten(n);

    vector<int> res(n);
    for (int i = 1; i <= n; ++i) {
        // cout << "current prefix: " << i << endl;
        for (int div : divs[i]) {
            int prev = i - div;

            // cout << "tried: " << div << " " << prev << endl;

            if (prev == 0) {
                // cout << "prev is null" << endl;
                res[i - 1] = i;
                break;
            }

            if (res[prev - 1] > div) {
                continue;
            }

            if (hasPeriod(i, div)) {
                // cout << "succesful\n";
                res[i - 1] = div;
                break;
            }
        }
    }

    return res;
}
