#include<iostream>
#include<vector>

#include "periods.h"

using namespace std;

vector<vector<int>> erathosten(int n) {
    vector<int> not_prime(n + 3, false);
    not_prime[0] = not_prime[1] = true;

    vector<vector<int>> res(n + 3, {1});
    for (int i = 4; i <= n; i += 2) {
        res[i].push_back(2);
        not_prime[i] = true;
    }

    for (int i = 3; i <= n; ++i) {
        for (int j = 2 * i; j <= n; j += i) {
            res[j].push_back(i);
            not_prime[j] = true;
        }
    }

    for (int i = 2; i <= n; ++i) {
        res[i].push_back(i);
    }

    return res;
}

vector<int> findPeriods(int n) {
    vector<vector<int>> divs = erathosten(n);

    vector<int> res(n, -1);
    for (int i = 1; i <= n; ++i) {
        int all_divs = (int) divs[i].size();
        int limit = 0;

        while (limit < all_divs) {
            int div = divs[i][limit];
            int prev = i - div;

            if (prev == 0) {
                res[i - 1] = i;
                break;
            }

            if (res[prev - 1] <= div) {
                break;
            }
            ++limit;

            if (hasPeriod(i, div)) {
                res[i - 1] = div;
                break;
            }
        }

        if (res[i - 1] != -1) {
            continue;
        }

        int l = limit, r = all_divs - 1;
        while (l <= r) {
            int mid = (l + r) / 2;
            if (hasPeriod(i, divs[i][mid])) {
                r = mid - 1;
            } else {
                l = mid + 1;
            }
        }

        res[i - 1] = divs[i][l];
    }

    return res;
}
