#include<iostream>
#include<vector>

#include "periods.h"

using namespace std;

vector<vector<int>> erathosten(int n) {
    vector<int> not_prime(n + 3, false);
    not_prime[0] = not_prime[1] = true;

    vector<vector<int>> res(n + 3, {1});
    for (int i = 4; i <= n; i += 2) {
        res[i].push_back(2);
        not_prime[i] = true;
    }

    for (int i = 3; i <= n; ++i) {
        for (int j = 2 * i; j <= n; j += i) {
            res[j].push_back(i);
            not_prime[j] = true;
        }
    }

    for (int i = 2; i <= n; ++i) {
        res[i].push_back(i);
    }

    return res;
}

vector<int> findPeriods(int n) {
    vector<vector<int>> divs = erathosten(n);

    vector<int> res(n);
    for (int i = 1; i <= n; ++i) {
        vector<int> possible;

        for (int div : divs[i]) {
            int prev = i - div;

            if (prev == 0) {
                possible.push_back(div);
                break;
            }

            if (res[prev - 1] > div) {
                continue;
            }

            possible.push_back(div);

            /*if (hasPeriod(i, div)) {
                res[i - 1] = div;
                break;
            }*/
        }

        int l = 0, r = (int) possible.size() - 1;
        while (l <= r) {
            int mid = (l + r) /2;
            if (hasPeriod(i, possible[mid])) {
                r = mid - 1;
            } else {
                l = mid + 1;
            }
        }

        res[i - 1] = possible[r + 1];
    }

    return res;
}
