#include <stdio.h>
#define MAX_X 100001
#define MAX_N 111

int tree[MAX_N * 4];

int n, q;

int _update(int root, int root_l, int root_r, int l, int r, int x) {
	if (l <= root_l && root_r <= r) return tree[root] = x;
	if (root_r < l || r < root_l) return tree[root];
	int root_m = (root_l + root_r) / 2;
	_update(root * 2,     root_l,     root_m, l, r, x);
	_update(root * 2 + 1, root_m + 1, root_r, l, r, x);
	if (tree[root*2] == tree[root*2+1]) return tree[root] = tree[root*2];
	else return tree[root] = -1;
}

void update(int l, int r, int x) {
	_update(1, 0, n - 1, l, r, x);
}

int _query(int root, int root_l, int root_r, int l, int r) {
	if (l <= root_l && root_r <= r) return tree[root];
	if (root_r < l || r < root_l) return -2;
	int root_m = (root_l + root_r) / 2;
	int a = _query(root * 2,     root_l,     root_m, l, r);
	int b = _query(root * 2 + 1, root_m + 1, root_r, l, r);
	if (a == -2) return b;
	if (b == -2) return a;
	if (a != b)  return -1;
	else         return a;
}

bool query(int l, int r) {
	return _query(1, 0, n - 1, l, r) != -1;
}

int main() {
	scanf("%d%d", &n, &q);
	for (int i = 0; i < q; ++i) {
		int t;
		scanf("%d", &t);
		if (t == 1) {
			int l, r, x;
			l--;
			r--;
			scanf("%d%d%d", &l, &r, &x);
			update(l, r, x);
		} else {
			int l, r;
			l--;
			r--;
			scanf("%d%d", &l, &r);
			printf("%d\n", query(l, r) ? 1 : 0);
		}
	}
}
