#include <iostream>
#include <unordered_map>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 200005
#define module 1000000009
int br, q;
int sumtree[4 * MAXN], prodtree[4 * MAXN], intertree[4 * MAXN];
//sumtree
void fixsum(int idx, int from, int to)
{
    if(from == to) return;
    sumtree[2 * idx] += sumtree[idx];
    sumtree[2 * idx + 1] += sumtree[idx];
    sumtree[idx] = 0;
}
void updatesum(int idx, int from, int to, int left, int right, int val)
{
    if(left > right) return;
    fixsum(idx, from, to);
    if(to < left || from > right) return;
    if(from >= left && to <= right){
        sumtree[idx] += val; return;
    }
    int mid = (from + to) / 2;
    updatesum(2 * idx, from, mid, left, right, val);
    updatesum(2 * idx + 1, mid + 1, to, left, right, val);
}
int querysum(int idx, int from, int to, int what)
{
    fixsum(idx, from, to);
    if(what < from || what > to) return -1;
    if(from == to && to == what){
        return sumtree[idx];
    }
    int mid = (from + to) / 2;
    return max(querysum(2 * idx, from, mid, what), querysum(2 * idx + 1, mid + 1, to, what));
}

//prodtree
void fixprod(int idx, int from, int to)
{
    if(from == to) return;
    prodtree[2 * idx] *= prodtree[idx]; prodtree[2 * idx] %= module;
    prodtree[2 * idx + 1] *= prodtree[idx]; prodtree[2 * idx + 1] %= module;
    prodtree[idx] = 1;
}
void updateprod(int idx, int from, int to, int left, int right, int val)
{
    if(left > right) return;
    fixprod(idx, from, to);
    if(to < left || from > right) return;
    if(from >= left && to <= right){
        prodtree[idx] *= val; prodtree[idx] %= module; return;
    }
    int mid = (from + to) / 2;
    updateprod(2 * idx, from, mid, left, right, val);
    updateprod(2 * idx + 1, mid + 1, to, left, right, val);
}
int queryprod(int idx, int from, int to, int what)
{
    fixprod(idx, from, to);
    if(what < from || what > to) return -1;
    if(from == to && to == what){
        return prodtree[idx];
    }
    int mid = (from + to) / 2;
    return max(queryprod(2 * idx, from, mid, what), queryprod(2 * idx + 1, mid + 1, to, what));
}

//intertree
void fixinter(int idx, int from, int to)
{
    if(from == to) return;
    if(intertree[idx] == -1) return;
    intertree[2 * idx] = intertree[idx];
    intertree[2 * idx + 1] = intertree[idx];
}
void updateinter(int idx, int from, int to, int left, int right, int val)
{
    if(left > right) return;
    fixinter(idx, from, to);
    if(to < left || from > right) return;
    if(from >= left && to <= right){
        intertree[idx] = val; return;
    }
    if(intertree[idx] != -1){
        if(intertree[idx] == val) return;
        intertree[idx] = -1;
    }
    int mid = (from + to) / 2;
    updateinter(2 * idx, from, mid, left, right, val);
    updateinter(2 * idx + 1, mid + 1, to, left, right, val);
}
int queryinter(int idx, int from, int to, int what)
{
    fixinter(idx, from, to);
    if(what < from || what > to) return -1;
    if(intertree[idx] != -1) return intertree[idx];
    if(from == to && to == what){ //za vseki sluchai
        return intertree[idx];
    }
    int mid = (from + to) / 2;
    return max(queryinter(2 * idx, from, mid, what), queryinter(2 * idx + 1, mid + 1, to, what));
}

unordered_map<int, pair<int, int> > inters;
int way;
void create(int beg, int from)
{
    if(beg > from) return;
    //cout << "Creating interval " << beg << ' ' << from << endl;
    ++way;
    inters.insert({way, {beg, from}});
    updateinter(1, 1, br, beg, from, way);
}
void unite(int one, int two)
{
    int interone = queryinter(1, 1, br, one), intertwo = queryinter(1, 1, br, two);
    if(interone == intertwo) return;
    //cout << "Uniting " << one << ' ' << two << ' ' << interone << ' ' << intertwo << endl;
    int begl = inters[interone].first, endr = inters[intertwo].second;
    create(begl, endr);
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); //cout.tie(0);
    for(int i = 0; i < 4 * MAXN; ++i) prodtree[i] = 1;
    cin >> br >> q;
    inters.insert({0, {1, br}});
    way = 1;
    for(int i = 0; i < q; ++i){
        int type; cin >> type;
        if(type == 1){
            int from, to, val; cin >> from >> to >> val;
            //cout << "query type 1 " << from << ' ' << to << ' ' << val << ' ' << endl;
            int interfrom = queryinter(1, 1, br, from), interto = queryinter(1, 1, br, to);
            //cout << "interfrom: " << interfrom << "  interto: " << interto << endl;
            updatesum(1, 1, br, from, to, val);
            updateprod(1, 1, br, from, to, val);

            int beg = inters[interfrom].first, en = inters[interto].second;
            //cout << "beg: " << beg << " en: " << en << endl;
            create(beg, from - 1);
            create(to + 1, en);
            if(interfrom == interto){
                //cout << "Interfrom equals interto\n";
                create(from, to);
            }
            else{
                //cout << "Interfrom and interto are different\n";
                int enl = inters[interfrom].second, begr = inters[interto].first;
                //cout << "enl: " << enl << " begr: " << begr << endl;
                create(from, enl); create(begr, to);
            }
            if(from > 1){
                //cout << "Case1\n";
                int sumfrom = querysum(1, 1, br, from), prodfrom = queryprod(1, 1, br, from);
                int sumbef = querysum(1, 1, br, from - 1), prodbef = queryprod(1, 1, br, from - 1);
                //cout << sumbef << ' ' << sumfrom << endl;
                //cout << prodbef << ' ' << prodfrom << endl;
                if(sumfrom == sumbef && prodfrom == prodbef){
                    //cout << "OK1\n";
                    unite(from - 1, from);
                }
            }
            if(to < br){
                //cout << "Case2\n";
                int sumto = querysum(1, 1, br, to), prodto = queryprod(1, 1, br, to);
                int sumnext = querysum(1, 1, br, to + 1), prodnext = queryprod(1, 1, br, to + 1);
                //cout << sumto << ' ' << sumnext << endl;
                //cout << prodto << ' ' << prodnext << endl;
                if(sumto == sumnext && prodto == prodnext){
                    //cout << "OK2\n";
                    unite(to, to + 1);
                }
            }
        }
        else{
            int from, to; cin >> from >> to;
            //cout << "Query type 2 " << from << ' ' << to << endl;
            int interfrom = queryinter(1, 1, br, from), interto = queryinter(1, 1, br, to);
            //cout << "Interfrom: " << interfrom << " Interto: " << interto << endl;
            cout << (interfrom == interto) << endl;
        }
        //cout << endl;
    }
    return 0;
}
