
#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}

const ll BASES = 3;
const ll mod[BASES] = {1000000009, 1000000007, 2000000069};
const ll base[BASES] = {100069, 200013, 100007};

struct Node {
    ll val[BASES], lazy[3];
    bool eq;
    Node() {
        for(ll i = 0; i < 3; i ++) {
            val[i] = 0;
            lazy[i] = 0;
        }
        eq = true;
    }
    Node(ll v) {
        val[0] = val[1] = val[2] = -1;
        eq = true;
    }
};

Node operator +(const Node &a, const Node &b) {
    Node ret;
    if(a.val[0] == -1) {return b;}
    if(b.val[0] == -1) {return a;}
    ret.eq = false;
    if(!a.eq || !b.eq) {return ret;}
    for(ll i = 0; i < 3; i ++) {
        if(a.val[i] != b.val[i]) {
            return ret;
        }
    }
    return a;
}

const ll MAX_N = 1e5 + 10;
Node tree[4 * MAX_N];

void push(ll curr, ll l, ll r) {
    for(ll i = 0; i < BASES; i ++) {
        tree[curr].val[i] = (tree[curr].val[i] + tree[curr].lazy[i]) % mod[i];
    }
    if(l != r) {
        for(ll i = 0; i < BASES; i ++) {
            tree[curr * 2].lazy[i] = (tree[curr * 2].lazy[i] + tree[curr].lazy[i]) % mod[i];
            tree[curr * 2 + 1].lazy[i] = (tree[curr * 2 + 1].lazy[i] + tree[curr].lazy[i]) % mod[i];
        }
    }
    for(ll i = 0; i < BASES; i ++) {
        tree[curr].lazy[i] = 0;
    }
}

void upd(ll curr, ll l, ll r, ll ql, ll qr, vector<ll> &val) {
    push(curr, l, r);
    if(ql <= l && r <= qr) {
        for(ll i = 0; i < BASES; i ++) {
            tree[curr].lazy[i] = (tree[curr].lazy[i] + val[i]) % mod[i];
        }
        push(curr, l, r);
        return;
    } else if(ql > r || qr < l) {return;}
    ll m = (l + r) / 2ll;
    upd(curr * 2, l, m, ql, qr, val);
    upd(curr * 2 + 1, m + 1, r, ql, qr, val);
    tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
}

Node ret(ll curr, ll l, ll r, ll ql, ll qr) {
    push(curr, l, r);
    if(ql <= l && r <= qr) {
        return tree[curr];
    } else if(l > qr || r < ql) {
        return Node(-1);
    }
    ll m = (l + r) / 2ll;
    Node f = ret(curr * 2, l, m, ql, qr);
    Node s = ret(curr * 2 + 1, m + 1, r, ql, qr);
    return f + s;
}

void prll(ll curr, ll l, ll r, ll ql, ll qr) {
    push(curr, l, r);
    if(l == r && ql <= l && l <= qr) {
        cout << "(";
        for(ll i = 0; i < BASES; i ++) {
            cout << tree[curr].val[i] << ",";
        }
        cout << ")";
        return;
    } else if(l == r) {return;}
    ll m = (l + r) / 2ll;
    prll(curr * 2, l, m, ql, qr);
    prll(curr * 2 + 1, m + 1, r, ql, qr);
}

ll n, q;

ll fpow(ll x, ll p, ll m) {
    if(p == 0) {return 1;}
    ll ans = fpow(x, p / 2ll, m); ans = (ans * ans) % m;
    if(p & 1) {
        return (ans * x) % m;
    } else {
        return ans;
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> q;
    while(q --) {
        ll t;
        cin >> t;
        if(t == 2) {
            ll l, r;
            cin >> l >> r;
            cout << ret(1, 0, MAX_N - 1, l, r).eq << endl;
        } else {
            ll l, r, a;
            cin >> l >> r >> a;
            vector<ll> val;
            for(ll i = 0; i < BASES; i ++) {
                val.push_back(fpow(base[i], a, mod[i]));
            }
            upd(1, 0, MAX_N - 1, l, r, val);
        }
    }
    return 0;
}

/*
4 7
2 1 3
1 1 3 5
1 3 4 6
2 1 3
2 1 2
1 2 2 5
2 1 2
*/


