#include <iostream>
#include <cstdlib>
using namespace std;

const int MAXN = 1048576;

struct vert
{
    long long val;
    long long lazy;
    bool eq;
};

struct qtype
{
    long long val;
    bool eq;
};

vert tree[MAXN]; // ravni li sa decata i ako da na kolko
int n, q, t, li, ri;
long long xi;

int updateTree(int ind, int l, int r, int tl, int tr, long long val)
{
    if(tree[ind].lazy > 0){
        tree[ind].val += tree[ind].lazy;
        if(l != r){
            tree[2*ind].lazy += tree[ind].lazy;
            tree[2*ind+1].lazy += tree[ind].lazy;
        }
        tree[ind].lazy = 0;
    }
    if(r < tl || l > tr) return tree[ind].val;
    if(l >= tl && r <= tr){
        tree[ind].val += val;
        if(l != r){
            tree[2*ind].lazy += val; tree[2*ind+1].lazy += val;
        }
        return tree[ind].val;
    }

    int m = (l + r)/2;
    updateTree(2*ind, l, m, tl, tr, val);
    updateTree(2*ind+1, m+1, r, tl, tr, val);
    if((tree[2*ind].eq || l == m) && (tree[2*ind+1].eq || m+1 == r) && tree[2*ind].val == tree[2*ind+1].val){
        tree[ind].eq = true;
        tree[ind].val = tree[2*ind].val;
    }else{
        tree[ind].eq = false;
    }
    return tree[ind].val;
}

qtype query(int ind, int l, int r, int tl, int tr)
{
    if(tree[ind].lazy > 0){
        tree[ind].val += tree[ind].lazy;
        if(l != r){
            tree[2*ind].lazy += tree[ind].lazy;
            tree[2*ind+1].lazy += tree[ind].lazy;
        }
        tree[ind].lazy = 0;
    }
    if(l > tr || r < tl) return {-1, true};
    if(l >= tl && r <= tr){
        if(l == r) return {tree[ind].val, true};
        return {tree[ind].val, tree[ind].eq};
    }

    int m = (l + r)/2;
    qtype a = query(2*ind, l, m, tl, tr);
    qtype b = query(2*ind+1, m+1, r, tl, tr);
    if(a.eq && b.eq){
        if(a.val == b.val || a.val == -1 || b.val == -1){
            return {max(a.val, b.val), true};
        }else{
            return {-1, false};
        }
    }else{
        return {-1, false};
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> q;
    for(int i = 0; i < 5*n; i++){
        tree[i].eq = true;
    }
    for(int i = 0; i < q; i++){
        cin >> t;
        if(t == 1){
            cin >> li >> ri >> xi;
            updateTree(1, 1, n, li, ri, xi);
        }
        if(t == 2){
            cin >> li >> ri;
            qtype ans = query(1, 1, n, li, ri);
            cout << ans.eq << endl;
        }
    }

return 0;
}
