#include <iostream>
#include <vector>
#include <cmath>
#include "periods.h"
using namespace std;

vector<int> ans;
int stpoint;

int binSearch(int p, int n)
{
    int l = max(stpoint/p, 1);
    int r = n/p;
    while(l != r){
        int m = (l+r+1)/2;
        if(m == 1){break;}
        bool c = hasPeriod(p*m, p);
        if(c){
            l = m;
            continue;
        }else{
            r = m-1;
            continue;
        }
    }
    return l;
}

vector<int> findPeriods(int n)
{
    if(n > 100){
        stpoint = 1;
        ans.resize(n, -1);
        int curr = 2; int k = 1;
        ans[0] = 1;
        for(k = 1; k <= n; k++){
            if(k <= sqrt(n)){
                int posl = binSearch(k, n);
                if(k == 1) stpoint = posl;
                for(int i = 1; i <= posl; i++){
                    if(ans[k*i-1] == -1) ans[k*i-1] = k;
                }
            }else{
                for(int j = 1; k*j <= n; j++){
                    if(k*j == 1) continue;
                    if(ans[k*j-1] != -1) continue;
                    if(j == 1){
                        ans[k-1] = k;
                        continue;
                    }
                    if(hasPeriod(j*k ,k)){
                        ans[k*j-1] = k;
                    }else{
                        break;
                    }
                }
            }
        }
        return ans;
    }else{
        ans.resize(n, -1);
        int curr = 2; int k = 1;
        ans[0] = 1;
        for(k = 1; k <= n; k++){
            for(int j = 1; k*j <= n; j++){
                if(k*j == 1) continue;
                if(ans[k*j-1] != -1) continue;
                if(j == 1){
                    ans[k-1] = k;
                    continue;
                }
                if(hasPeriod(j*k ,k)){
                    ans[k*j-1] = k;
                }else{
                    break;
                }
            }
        }
        return ans;
    }
}
