#include<iostream>
using namespace std;

struct tree
{
    int from, to, liquid;
    bool same;

    tree *left, *right;

    tree(){left=NULL, right=NULL;}
};

struct result
{
    bool same;
    int liquid;
};

void BuildTree(tree *&t, int from, int to)
{
    t=new tree;
    t->from=from, t->to=to, t->liquid=0, t->same=true;

    if(from!=to)
    {
        BuildTree(t->left, from, (from+to)/2);
        BuildTree(t->right, (from+to)/2+1, to);
    }

    return;
}

void AddTree(tree *&t, int from, int to, int x)
{
    if(t->from==t->to)
    {
        t->liquid=x;
        return;
    }

    if(from>t->left->to)
    {
        AddTree(t->right, from, to, x);
    }
    else if(to<=t->left->to)
    {
        AddTree(t->left, from, to, x);
    }
    else
    {
        AddTree(t->left, from, t->left->to, x);
        AddTree(t->right, t->right->from, to, x);
    }

    if(t->left->same && t->right->same && t->left->liquid==t->right->liquid)
    {
        t->same=true;
        t->liquid=t->left->liquid;
    }
    else
    {
        t->same=false;
    }

    return;
}

result CheckTree(tree *&t, int from, int to)
{
    if(t->from==from && t->to==to)
    {
        result r;
        r.same=t->same;
        r.liquid=t->liquid;

        return r;
    }

    if(from>t->left->to)
    {
        if(t->same)
        {
            t->right->liquid=t->liquid;
            t->right->same=true;
        }

        return CheckTree(t->right, from, to);
    }
    else if(to<=t->left->to)
    {
        if(t->same)
        {
            t->left->liquid=t->liquid;
            t->left->same=true;
        }

        return CheckTree(t->left, from, to);
    }
    else
    {
        if(t->same)
        {
            t->left->liquid=t->liquid;
            t->left->same=true;

            t->right->liquid=t->liquid;
            t->right->same=true;
        }

        result r1=CheckTree(t->left, from, t->left->to), r2=CheckTree(t->right, t->right->from, to);

        if(r1.same && r2.same && r1.liquid==r2.liquid)
        {
            return r1;
        }
        else
        {
            r1.same=false;
            return r1;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, q;
    cin >> n >> q;

    tree *t=NULL;

    BuildTree(t, 1, n);

    while(q>0)
    {
        int type;
        cin >> type;

        if(type==1)
        {
            int from, to, x;
            cin >> from >> to >> x;

            AddTree(t, from, to, x);
        }
        else
        {
            int from, to;
            cin >> from >> to;

            if(CheckTree(t, from, to).same)
            {
                cout << 1 << "\n";
            }
            else
            {
                cout << 0 << "\n";
            }
        }

        q--;
    }

    return 0;
}
/*
4 3
1 1 2 1
1 3 3 1
2 1 4
*/
