#pragma GCC optimize("O3")
#pragma GCC optimize("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long int
#define ld long double
#define bit(idx) idx&(-idx)
#define bin(x) bitset<32>(x).to_string()
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x) -> how many elements are smaller than x

const ll MAXN = 2e5 + 5;
const ll MOD = 1e9 + 7;
const ll BASE = 2;

struct Node{
    ll val, lazy;
};

Node segmtree[4 * MAXN];
int n, q, basePowers[MAXN];

void init(){
    basePowers[0] = 1;
    for(int i = 1; i < MAXN; i ++)
        basePowers[i] = (basePowers[i - 1] * BASE) % MOD;
}

void push(ll node, ll l, ll r){
    /// cout << "pushing " << node << " " << l << " " << r << endl;
    /// cout << "prev " << segmtree[node].val << " " << segmtree[node].lazy << endl;
    if(segmtree[node].val != -1){
        segmtree[node].val = (segmtree[node].val + segmtree[node].lazy) % MOD;
    }
    if(l != r){
        segmtree[2 * node + 0].lazy = (segmtree[node].lazy + segmtree[2 * node + 0].lazy) % MOD;
        segmtree[2 * node + 1].lazy = (segmtree[node].lazy + segmtree[2 * node + 1].lazy) % MOD;
    }
    segmtree[node].lazy = 0;
    /// cout << "now  " << segmtree[node].val << " " << segmtree[node].lazy << endl;
}

void upd(ll node, ll l, ll r, ll ql, ll qr, ll x){
    if(r < ql || qr < l){
        return;
    }
    else if(ql <= l && r <= qr){
        push(node, l, r);
        segmtree[node].lazy = (segmtree[node].lazy + x) % MOD;
    }
    else{
        ll m = (l + r) / 2;
        push(node, l, r);
        upd(2 * node + 0, l + 0, m, ql, qr, x);
        upd(2 * node + 1, m + 1, r, ql, qr, x);
        push(2 * node + 0, l + 0, m);
        push(2 * node + 1, m + 1, r);
        if(segmtree[2 * node].val == segmtree[2 * node + 1].val){
            segmtree[node].val = segmtree[2 * node].val;
        }
        else{
            segmtree[node].val = -1;
        }
    }
}

ll qry(ll node, ll l, ll r, ll ql, ll qr){
    /// cout << "curr in " << node << " " << l << " " << r << endl;
    if(r < ql || qr < l){
        return -2;
    }
    else if(ql <= l && r <= qr){
        push(node, l, r);
        return segmtree[node].val;
    }
    else{
        int m = (l + r) / 2;
        push(node, l, r);
        push(2 * node, l, m);
        push(2 * node + 1, m + 1, r);
        ll q1 = qry(2 * node, l, m, ql, qr);
        ll q2 = qry(2 * node + 1, m + 1, r, ql, qr);
        if(q1 == -2){
            return q2;
        }
        else if(q2 == -2){
            return q1;
        }
        else if(q1 == -1 || q2 == -1 || q1 != q2){
            return -1;
        }
        else if(q1 != -1 && q2 != -1 && q1 == q2){
            return q1;
        }
        else{
            return -1;
        }
    }
}

void upd(ll l, ll r, ll x){ upd(1, 1, n, l, r, x); }
ll qry(ll l, ll r){ return qry(1, 1, n, l, r); }
void print(){
    for(int i = 1; i <= 4 * n; i ++){
        cout << i << ": " << segmtree[i].val << " " << segmtree[i].lazy << endl;
    }
}

int main(){
    /// ios_base::sync_with_stdio(false); cin.tie(NULL);
    /// freopen("INOPUT.txt","r",stdin);
    /// freopen("OUTPUT.txt","w",stdout);
    init();
    cin >> n >> q;
    for(int i = 0; i < q; i ++){
        int t; cin >> t;
        if(t == 1){
            ll x, l, r; cin >> l >> r >> x;
            x = basePowers[x - 1];
            upd(l, r, x);
        }
        else{
            ll l, r; cin >> l >> r;
            cout << (qry(l, r) != -1) << endl;
        }
        /// print();
    }
}
/**
4 7
2 1 3
1 1 3 5
1 3 4 6
2 1 3
2 1 2
1 2 2 5
2 1 2

1
0
1
0
*/
