#include <bits/stdc++.h>

#define int long long

const int MAXN = 2e5 + 10, mod1 = 1e9 + 7, mod2 = 1e9 + 9, INF = 1e10;

std::pair<int, int> tree1[4 * MAXN], tree2[4 * MAXN];

std::pair<int, int> st(int n)
{
    if(n == 0)
        return {1, 1};

    auto ans = st(n / 2);
    ans = {(ans.first * ans.first) % mod1, (ans.second * ans.second) % mod2};

    if(n % 2)
    {
        ans = {(ans.first * 10) % mod1, (ans.second * 10) % mod2};
    }

    return ans;
}

std::pair<std::pair<int, int>, std::pair<int, int> > update(int ind, int tl, int tr, int ql, int qr, const std::pair<int, int>& val)
{
    if(ql >= tr || qr <= tl)
    {
        return {tree1[ind], tree2[ind]};
    }

    if(tl == tr - 1)
    {
        //auto step = st(val);
        int newval1 = (tree1[ind].first + val.first) % mod1,
            newval2 = (tree2[ind].first + val.second) % mod2;
        tree1[ind] = {newval1, newval1};
        tree2[ind] = {newval2, newval2};

        return {tree1[ind], tree2[ind]};
    }

    auto left = update(ind * 2, tl, (tl + tr) / 2, ql, qr, val),
         right = update(ind * 2 + 1, (tl + tr) / 2, tr, ql, qr, val);

    tree1[ind] = {std::min(left.first.first, right.first.first), std::max(left.first.second, right.first.second)};
    tree2[ind] = {std::min(left.second.first, right.second.first), std::max(left.second.second, right.second.second)};

    return {tree1[ind], tree2[ind]};
}

std::pair<std::pair<int, int>, std::pair<int, int> > calc(int ind, int tl, int tr, int ql, int qr)
{
    if(ql >= tr || qr <= tl)
    {
        return {{INF, 0}, {INF, 0}};
    }
    if(ql <= tl && tr <= qr)
    {
        //std::cout << 'a';
        return {tree1[ind], tree2[ind]};
    }

    auto left = calc(ind * 2, tl, (tl + tr) / 2, ql, qr),
         right = calc(ind * 2 + 1, (tl + tr) / 2, tr, ql, qr);

    return {{std::min(left.first.first, right.first.first), std::max(left.first.second, right.first.second)},
            {std::min(left.second.first, right.second.first), std::max(left.second.second, right.second.second)}};
}

signed main()
{
    int n, q;
    std::pair<int, int> newval;
    std::cin >> n >> q;

    for(int i = 0; i < q; ++ i)
    {
        int cq;
        std::cin >> cq;
        if(cq == 1)
        {
            int a, b, c;
            std::cin >> a >> b >> c;
            newval = st(c);

            update(1, 0, n, a, b + 1, newval);
        }else
        {
            int a, b;
            std::cin >> a >> b;

            auto ans = calc(1, 0, n, a, b + 1);

            if(ans.first.first == ans.first.second && ans.second.first == ans.second.second)
            {
                std::cout << "1\n";
            }else
            {
                std::cout << "0\n";
            }
        }
    }

    return 0;
}

